package com.example.fragment;

import com.example.fragment.menu.MenuBar;

import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.LinearLayout;
import android.widget.TextView;


/**
 * Contents\WebView쐬/XVsB
 */
public class ContentFragment extends Fragment {
	private static final int TEXT_VIEW_INDEX = 0;
	private static final int WEB_VIEW_INDEX = 1;
    /**
     * Contenẗɕ\View̍쐬
     * @return \ViewԂ
     */
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
    	LinearLayout l = new LinearLayout(getActivity());
    	l.setOrientation(LinearLayout.VERTICAL);
    	TextView title = new TextView(getActivity());
    	//WebView̐
        WebView web = new WebView(getActivity());  
        l.addView(title,0); 
        l.addView(web,WEB_VIEW_INDEX);
        return l;  
    }

    /**
     * ContentFragment̍XV
     * @param category	ANVo[̉ʒu
     * @param position	j[̉ʒu
     */
    public void updateContentAndRecycleView(int category, int position) {
        String name = MenuBar.getCategory(category).getEntry(position).getName();
        String url = MenuBar.getCategory(category).getEntry(position).getUrl();
        ((TextView)((LinearLayout)getView()).getChildAt(TEXT_VIEW_INDEX)).setText(name);
       ((WebView)((LinearLayout)getView()).getChildAt(WEB_VIEW_INDEX)).loadUrl(url);
    }
}
