package com.example.touch;
import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.Window;
import android.widget.LinearLayout;
import android.widget.TextView;

/**
 * ^b`Cxg̕\Tv
 */
public class TouchSample extends Activity {
	
	/** L[{[h̃^Cg */
    private TextView softKeyBoardTitle;

    /** L[{[h̒l */
    private TextView softKeyBoardValue;
    
    /** L[{[h̃ANV */
    private TextView softKeyBoardAction;
    
    /** ^b`Cxg̃^Cg */
    private TextView touchTitle;
    
    /** ^b`CxgXW */
    private TextView touchX;
    
    /** ^b`CxgYW */
    private TextView touchY;
    
    /** ^b`Cxg̃ANV */
    private TextView touchAction;
    
    /** gbN{[̃^Cg */
    private TextView trackballTitle;
    
    /** gbN{[XW */
    private TextView trackballX;
    
    /** gbN{[YW */
    private TextView trackballY;
    
    private TextView trackballAction;
    /**
     * ꂽ\tgEFAL[{[h\
     * @param keyCode	
     * @param event
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
    	softKeyBoardAction.setText(getActionName(event.getAction()));
    	softKeyBoardValue.setText(getKeyCode(keyCode));
        return true;
    }
    /**
     * AKeyUpꂽ\tgEFAL[{[h\
     * @param keyCode
     * @param event
     */
    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event){
    	softKeyBoardAction.setText(getActionName(event.getAction()));
    	softKeyBoardValue.setText(getKeyCode(keyCode));
        return true;
    }
    /**
     * ^b`ꂽfBXvC̍WAANV\
     * @param event
     */
    @Override
    public boolean onTouchEvent(MotionEvent event){
    	touchX.setText(String.valueOf(event.getX()));
    	touchY.setText(String.valueOf(event.getY()));
    	touchAction.setText(getActionName(event.getAction()));
    	return true;
    }
    /**
     * gbN{[̍WAANV\
     * @param event
     */
    @Override
    public boolean onTrackballEvent(MotionEvent event){
    	trackballX.setText(String.valueOf(event.getX()));
    	trackballY.setText(String.valueOf(event.getY()));
    	trackballAction.setText(getActionName(event.getAction()));
    	return true;
    }

    /**
     * AvP[V̏
     * @param event
     */
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        //AvP[V^Cg\
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        //CAEgc\ɐݒ
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        
        //\tgEFAL[{[h̕\̈
        softKeyBoardTitle = new TextView(this);
        softKeyBoardAction = new TextView(this);
        softKeyBoardValue = new TextView(this);
        
        //^b`Cxg̕\̈
        touchTitle = new TextView(this);
        touchX = new TextView(this);
        touchY = new TextView(this);
        touchAction = new TextView(this);
        
        //gbN{[̕\̈
        trackballTitle = new TextView(this);
        trackballX = new TextView(this);
        trackballY = new TextView(this);
        trackballAction = new TextView(this);
        
        //^Cg̐ݒ
        softKeyBoardTitle.setText("\tgEFAL[{[hF");
        touchTitle.setText("ʃCxgF");
        trackballTitle.setText("gbN{[CxgF");
        
        //e\̈CAEgɐݒ
        layout.addView(softKeyBoardTitle);
        layout.addView(softKeyBoardValue);
        layout.addView(softKeyBoardAction);
        layout.addView(touchTitle);
        layout.addView(touchX);
        layout.addView(touchY);
        layout.addView(touchAction);
        layout.addView(trackballTitle);
        layout.addView(trackballX);
        layout.addView(trackballY);
        layout.addView(trackballAction);
        setContentView(layout);
    }
    /**
     * MotionEvent.getAction疼̂擾
     * @param motionAction	motionActionl
     * @return	motionAction
     */
    private String getActionName(int motionAction){
    	String ret = "";
    	if(motionAction == MotionEvent.ACTION_CANCEL){
    		ret = "ACTION_CANCEL";
    	}else if(motionAction == MotionEvent.ACTION_DOWN){
    		ret = "ACTION_DOWN";
    	}else if(motionAction == MotionEvent.ACTION_MOVE){
    		ret = "ACTION_MOVE";
    	}else if(motionAction == MotionEvent.ACTION_OUTSIDE){
    		ret = "ACTION_OUTSIDE";
    	}else if(motionAction == MotionEvent.ACTION_UP){
    		ret = "ACTION_UP";
    	}
    	return ret;
    }
    /**
     * KeyEvent.getKeyCode牟ꂽL[R[h擾
     * @param keyCode	KeyCodel
     * @return	L[R[h
     */
    private String getKeyCode(int keyCode){

		String ret = "";
	    if(keyCode == KeyEvent.KEYCODE_UNKNOWN){
			ret =  "KEYCODE_UNKNOWN";
	    }else if(keyCode == KeyEvent.KEYCODE_SOFT_LEFT){
			ret =  "KEYCODE_SOFT_LEFT";
	    }else if(keyCode == KeyEvent.KEYCODE_SOFT_RIGHT){
			ret =  "KEYCODE_SOFT_RIGHT";
	    }else if(keyCode == KeyEvent.KEYCODE_HOME){
			ret =  "KEYCODE_HOME";
	    }else if(keyCode == KeyEvent.KEYCODE_BACK){
			ret =  "KEYCODE_BACK";
	    }else if(keyCode == KeyEvent.KEYCODE_CALL){
			ret =  "KEYCODE_CALL";
	    }else if(keyCode == KeyEvent.KEYCODE_ENDCALL){
			ret =  "KEYCODE_ENDCALL";
	    }else if(keyCode == KeyEvent.KEYCODE_0){
			ret =  "KEYCODE_0";
	    }else if(keyCode == KeyEvent.KEYCODE_1){
			ret =  "KEYCODE_1";
	    }else if(keyCode == KeyEvent.KEYCODE_2){
			ret =  "KEYCODE_2";
	    }else if(keyCode == KeyEvent.KEYCODE_3){
			ret =  "KEYCODE_3";
	    }else if(keyCode == KeyEvent.KEYCODE_4){
			ret =  "KEYCODE_4";
	    }else if(keyCode == KeyEvent.KEYCODE_5){
			ret =  "KEYCODE_5";
	    }else if(keyCode == KeyEvent.KEYCODE_6){
			ret =  "KEYCODE_6";
	    }else if(keyCode == KeyEvent.KEYCODE_7){
			ret =  "KEYCODE_7";
	    }else if(keyCode == KeyEvent.KEYCODE_8){
			ret =  "KEYCODE_8";
	    }else if(keyCode == KeyEvent.KEYCODE_9){
			ret =  "KEYCODE_9";
	    }else if(keyCode == KeyEvent.KEYCODE_STAR){
			ret =  "KEYCODE_STAR";
	    }else if(keyCode == KeyEvent.KEYCODE_POUND){
			ret =  "KEYCODE_POUND";
	    }else if(keyCode == KeyEvent.KEYCODE_DPAD_UP){
			ret =  "KEYCODE_DPAD_UP";
	    }else if(keyCode == KeyEvent.KEYCODE_DPAD_DOWN){
			ret =  "KEYCODE_DPAD_DOWN";
	    }else if(keyCode == KeyEvent.KEYCODE_DPAD_LEFT){
			ret =  "KEYCODE_DPAD_LEFT";
	    }else if(keyCode == KeyEvent.KEYCODE_DPAD_RIGHT){
			ret =  "KEYCODE_DPAD_RIGHT";
	    }else if(keyCode == KeyEvent.KEYCODE_DPAD_CENTER){
			ret =  "KEYCODE_DPAD_CENTER";
	    }else if(keyCode == KeyEvent.KEYCODE_VOLUME_UP){
			ret =  "KEYCODE_VOLUME_UP";
	    }else if(keyCode == KeyEvent.KEYCODE_VOLUME_DOWN){
			ret =  "KEYCODE_VOLUME_DOWN";
	    }else if(keyCode == KeyEvent.KEYCODE_POWER){
			ret =  "KEYCODE_POWER";
	    }else if(keyCode == KeyEvent.KEYCODE_CAMERA){
			ret =  "KEYCODE_CAMERA";
	    }else if(keyCode == KeyEvent.KEYCODE_CLEAR){
			ret =  "KEYCODE_CLEAR";
	    }else if(keyCode == KeyEvent.KEYCODE_A){
			ret =  "KEYCODE_A";
	    }else if(keyCode == KeyEvent.KEYCODE_B){
			ret =  "KEYCODE_B";
	    }else if(keyCode == KeyEvent.KEYCODE_C){
			ret =  "KEYCODE_C";
	    }else if(keyCode == KeyEvent.KEYCODE_D){
			ret =  "KEYCODE_D";
	    }else if(keyCode == KeyEvent.KEYCODE_E){
			ret =  "KEYCODE_E";
	    }else if(keyCode == KeyEvent.KEYCODE_F){
			ret =  "KEYCODE_F";
	    }else if(keyCode == KeyEvent.KEYCODE_G){
			ret =  "KEYCODE_G";
	    }else if(keyCode == KeyEvent.KEYCODE_H){
			ret =  "KEYCODE_H";
	    }else if(keyCode == KeyEvent.KEYCODE_I){
			ret =  "KEYCODE_I";
	    }else if(keyCode == KeyEvent.KEYCODE_J){
			ret =  "KEYCODE_J";
	    }else if(keyCode == KeyEvent.KEYCODE_K){
			ret =  "KEYCODE_K";
	    }else if(keyCode == KeyEvent.KEYCODE_L){
			ret =  "KEYCODE_L";
	    }else if(keyCode == KeyEvent.KEYCODE_M){
			ret =  "KEYCODE_M";
	    }else if(keyCode == KeyEvent.KEYCODE_N){
			ret =  "KEYCODE_N";
	    }else if(keyCode == KeyEvent.KEYCODE_O){
			ret =  "KEYCODE_O";
	    }else if(keyCode == KeyEvent.KEYCODE_P){
			ret =  "KEYCODE_P";
	    }else if(keyCode == KeyEvent.KEYCODE_Q){
			ret =  "KEYCODE_Q";
	    }else if(keyCode == KeyEvent.KEYCODE_R){
			ret =  "KEYCODE_R";
	    }else if(keyCode == KeyEvent.KEYCODE_S){
			ret =  "KEYCODE_S";
	    }else if(keyCode == KeyEvent.KEYCODE_T){
			ret =  "KEYCODE_T";
	    }else if(keyCode == KeyEvent.KEYCODE_U){
			ret =  "KEYCODE_U";
	    }else if(keyCode == KeyEvent.KEYCODE_V){
			ret =  "KEYCODE_V";
	    }else if(keyCode == KeyEvent.KEYCODE_W){
			ret =  "KEYCODE_W";
	    }else if(keyCode == KeyEvent.KEYCODE_X){
			ret =  "KEYCODE_X";
	    }else if(keyCode == KeyEvent.KEYCODE_Y){
			ret =  "KEYCODE_Y";
	    }else if(keyCode == KeyEvent.KEYCODE_Z){
			ret =  "KEYCODE_Z";
	    }else if(keyCode == KeyEvent.KEYCODE_COMMA){
			ret =  "KEYCODE_COMMA";
	    }else if(keyCode == KeyEvent.KEYCODE_PERIOD){
			ret =  "KEYCODE_PERIOD";
	    }else if(keyCode == KeyEvent.KEYCODE_ALT_LEFT){
			ret =  "KEYCODE_ALT_LEFT";
	    }else if(keyCode == KeyEvent.KEYCODE_ALT_RIGHT){
			ret =  "KEYCODE_ALT_RIGHT";
	    }else if(keyCode == KeyEvent.KEYCODE_SHIFT_LEFT){
			ret =  "KEYCODE_SHIFT_LEFT";
	    }else if(keyCode == KeyEvent.KEYCODE_SHIFT_RIGHT){
			ret =  "KEYCODE_SHIFT_RIGHT";
	    }else if(keyCode == KeyEvent.KEYCODE_TAB){
			ret =  "KEYCODE_TAB";
	    }else if(keyCode == KeyEvent.KEYCODE_SPACE){
			ret =  "KEYCODE_SPACE";
	    }else if(keyCode == KeyEvent.KEYCODE_SYM){
			ret =  "KEYCODE_SYM";
	    }else if(keyCode == KeyEvent.KEYCODE_EXPLORER){
			ret =  "KEYCODE_EXPLORER";
	    }else if(keyCode == KeyEvent.KEYCODE_ENVELOPE){
			ret =  "KEYCODE_ENVELOPE";
	    }else if(keyCode == KeyEvent.KEYCODE_ENTER){
			ret =  "KEYCODE_ENTER";
	    }else if(keyCode == KeyEvent.KEYCODE_DEL){
			ret =  "KEYCODE_DEL";
	    }else if(keyCode == KeyEvent.KEYCODE_GRAVE){
			ret =  "KEYCODE_GRAVE";
	    }else if(keyCode == KeyEvent.KEYCODE_MINUS){
			ret =  "KEYCODE_MINUS";
	    }else if(keyCode == KeyEvent.KEYCODE_EQUALS){
			ret =  "KEYCODE_EQUALS";
	    }else if(keyCode == KeyEvent.KEYCODE_LEFT_BRACKET){
			ret =  "KEYCODE_LEFT_BRACKET";
	    }else if(keyCode == KeyEvent.KEYCODE_RIGHT_BRACKET){
			ret =  "KEYCODE_RIGHT_BRACKET";
	    }else if(keyCode == KeyEvent.KEYCODE_BACKSLASH){
			ret =  "KEYCODE_BACKSLASH";
	    }else if(keyCode == KeyEvent.KEYCODE_SEMICOLON){
			ret =  "KEYCODE_SEMICOLON";
	    }else if(keyCode == KeyEvent.KEYCODE_APOSTROPHE){
			ret =  "KEYCODE_APOSTROPHE";
	    }else if(keyCode == KeyEvent.KEYCODE_SLASH){
			ret =  "KEYCODE_SLASH";
	    }else if(keyCode == KeyEvent.KEYCODE_AT){
			ret =  "KEYCODE_AT";
	    }else if(keyCode == KeyEvent.KEYCODE_NUM){
			ret =  "KEYCODE_NUM";
	    }else if(keyCode == KeyEvent.KEYCODE_HEADSETHOOK){
			ret =  "KEYCODE_HEADSETHOOK";
	    }else if(keyCode == KeyEvent.KEYCODE_FOCUS){
			ret =  "KEYCODE_FOCUS";
	    }else if(keyCode == KeyEvent.KEYCODE_PLUS){
			ret =  "KEYCODE_PLUS";
	    }else if(keyCode == KeyEvent.KEYCODE_MENU){
			ret =  "KEYCODE_MENU";
	    }else if(keyCode == KeyEvent.KEYCODE_NOTIFICATION){
			ret =  "KEYCODE_NOTIFICATION";
	    }else if(keyCode == KeyEvent.KEYCODE_SEARCH){
			ret =  "KEYCODE_SEARCH";
	    }else if(keyCode == KeyEvent.KEYCODE_MEDIA_PLAY_PAUSE){
			ret =  "KEYCODE_MEDIA_PLAY_PAUSE";
	    }else if(keyCode == KeyEvent.KEYCODE_MEDIA_STOP){
			ret =  "KEYCODE_MEDIA_STOP";
	    }else if(keyCode == KeyEvent.KEYCODE_MEDIA_NEXT){
			ret =  "KEYCODE_MEDIA_NEXT";
	    }else if(keyCode == KeyEvent.KEYCODE_MEDIA_PREVIOUS){
			ret =  "KEYCODE_MEDIA_PREVIOUS";
	    }else if(keyCode == KeyEvent.KEYCODE_MEDIA_REWIND){
			ret =  "KEYCODE_MEDIA_REWIND";
	    }else if(keyCode == KeyEvent.KEYCODE_MEDIA_FAST_FORWARD){
			ret =  "KEYCODE_MEDIA_FAST_FORWARD";
	    }else if(keyCode == KeyEvent.KEYCODE_MUTE){
			ret =  "KEYCODE_MUTE";
	    }
	    return ret;
    }
}