package com.example.schedule;

import java.util.ArrayList;
import com.example.schedule.info.ScheduleInfo;
import com.example.schedule.util.ScheduleUtil;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;

/**
 * 
 * 
 * XPW[Xg\ANeBreB
 *
 */
public class ScheduleList extends Activity implements OnClickListener ,OnItemClickListener{
    ListView listView;    //XPW[ꗗ\Xg
    
    Button addBtn ;    //ǉ{^
    
    private final static int REQUEST_SCHEDULE_EDITOR=0;    //ҏWID
    
    //private final int FP = ViewGroup.LayoutParams.FILL_PARENT;//őTCYŕ\
    private final int WC = ViewGroup.LayoutParams.WRAP_CONTENT;//KvŒ̃TCYŕ\
    
    //schedule_list.txt̒lێNX
    private ArrayList<ScheduleInfo> lstScheduleList = new ArrayList<ScheduleInfo>();    
    
    
    /**
     * ʋNɎs
     * 
     */
    @Override
    public void onCreate(Bundle bundle) {

        super.onCreate(bundle);
        //ʃCAEg̐ݒ胁\bhĂяo
        setLayOut();           
        //XPW[Xg̓ǂݍ
        lstScheduleList = ScheduleUtil.getScheduleList(this); 
       //Xgr[\e̍XV
        getArrayAdapter();
        //A[Zbg
        ScheduleUtil.registAlarm(this);


    }
    /**
     * CAEg̐ݒ
     */
    private void setLayOut(){
        //XPW[ꗗXg̍쐬
        listView  = new ListView(this);  
        listView.setFocusableInTouchMode(true);
        listView.setOnItemClickListener(this);  

        
        //CAEg̐
        LinearLayout linearLayout = new LinearLayout(this);
        
        //CAEgɏcɔzu ɔzuꍇLinearLayout.HORIZONTAL
        linearLayout.setOrientation(LinearLayout.VERTICAL);
        setContentView(linearLayout);

        //CAEgɃXPW[ꗗ̒ǉ
        linearLayout.addView(listView, createParam(WC, 370));
        
        //XPW[ǉ{^𐶐
        addBtn = new Button(this);
        addBtn.setText("XPW[ǉ");
        
        //XPW[ǉ{^ɃXi[o^
        addBtn.setOnClickListener(this);
        
        //CAEgɃCAEgp^ݒ
        linearLayout.addView(addBtn, createParam(WC, WC));
    }
    /**
     * ANeBreBĂяoʂ̎擾
     * 
     * @param    requestCode    ANeBreBĂяoۂ̃NGXgR[h
     * @param    resultCode    ANeBreB̖߂l
     * @param    intent    ANeBreBԂňpIntent
     */
    @Override
    protected void onActivityResult(int requestCode,int resultCode,Intent intent) {
        //requestCodeMƓŁAresultCodenł
        if (requestCode == REQUEST_SCHEDULE_EDITOR && resultCode==RESULT_OK) {
            //p[^̎擾
            SharedPreferences pref=getSharedPreferences(
                    "PREVIOUS_RESULT",MODE_PRIVATE);
            //Jڌ̒l擾
            String command=pref.getString("command","");
            int    id     =pref.getInt("id",0);
            String title  =pref.getString("title","");
            String schedule  =pref.getString("schedule","");
            //XPW[Xg̍XVэ폜
            for (int i=0;i< lstScheduleList.size();i++) {
                ScheduleInfo info= lstScheduleList.get(i);
                if (info.getId()==id) {
                    if (command.equals("update")) {
                        info.setTitle(title);
                        info.setSchedule(schedule);
                        info.setCallFlag(true);
                        lstScheduleList.set(i, info);
                    } else if (command.equals("delete")) {
                        lstScheduleList.remove(i);
                    }                    
                    break;
                }
            }
            //XPW[Xg̏
            ScheduleUtil.writeScheduleList(this,lstScheduleList);
            getArrayAdapter();
        }
    }

    /**
     * CAEgp^̎擾
     * @param w    w
     * @param h    cw
     * @return    CAEgp^
     */
    private LinearLayout.LayoutParams createParam(int w, int h){
        return new LinearLayout.LayoutParams(w, h);
    }
    /**    
     * ListView̃Abvf[gA_v^    
     * @param scheduleList ListViewɕ\XPW[ꗗ    
     */    
    private void getArrayAdapter(){
        //XPW[Xg̃Xg擾
        //XPW[Xg^CgƓt擾StringzɊi[    
        String[] ret = new String[lstScheduleList.size()];
        for(int i = 0 ; i < lstScheduleList.size() ; i++){
            ScheduleInfo info = (ScheduleInfo)lstScheduleList.get(i);
           ret[i] = info.getTitle() + "[ " + info.getSchedule() + " ]";
        }    
        //쐬StringzArrayAdapter쐬    
        ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>(this, R.layout.schedulelistlayout, ret);    
        //ArrayAdapterListViewXV    
        listView.setAdapter(arrayAdapter);    
    }
    /**
     * {^ɃXPW[ڍ׉ʂ֑Jڂ
     * @param    viwe    ꂽ{^
     */
    public void onClick(View view) {
        //XPW[ǉ{^̏
        try{
            if(view == addBtn){
                //XPW[NX𐶐
                ScheduleInfo info = new ScheduleInfo();
                //XPW[ӂɂȂID
                info.setId(lstScheduleList.size());
                //XPW[ڍדo^ʂɕ\^Cg
                info.setTitle("VKXPW["); 
                //IntentɃXPW[XgʁiJڌjƁAXPW[ڍדo^ʁiJڐj̃NXw肷
                Intent intent=new Intent(
                        ScheduleList.this,
                        ScheduleEditor.class);
                //XPW[ڍדo^ʂֈnlIDƃ^Cgݒ
                intent.putExtra("id",info.getId());
                intent.putExtra("title",info.getTitle());
    
    
                //Intentɐݒ肵ActivityĂяo
                //}jtFXgActivityݒ肳ĂȂƃG[ƂȂ
                startActivityForResult(intent,REQUEST_SCHEDULE_EDITOR);
    
                //ʂ̃XgɌĂяolێ
                lstScheduleList.add(info);
            }
        }catch(Exception ex){
            ex.printStackTrace();
        }
    }
    /**
     * ListViewIɃXPW[ڍ׉ʂ֑Jڂ
     * @param    view    ꂽXgr[
     * @param    textview    Xgr[őIꂽXgr[̃r[IuWFNg
     * @param    position    IꂽXgr[̈ʒu
     * @param    id    ID
     */
    public void onItemClick(AdapterView<?> view, View textview,int position,long id) {
        //XPW[XgI
        if(view == listView){
            //Xgr[ƓʒuɂXPW[NXXg擾
            ScheduleInfo info= lstScheduleList.get(position);
            //IntentɃXPW[XgʁiJڌjƁAXPW[ڍדo^ʁiJڐj̃NXw肷
            Intent intent=new Intent(ScheduleList.this,ScheduleEditor.class);
            //XPW[ڍדo^ʂֈnlIDƃ^Cgݒ
            intent.putExtra("id",info.getId());
            intent.putExtra("title",info.getTitle());
            //Intentɐݒ肵ActivityĂяo
            //}jtFXgActivityݒ肳ĂȂƃG[ƂȂ
            startActivityForResult(intent,REQUEST_SCHEDULE_EDITOR);

        }
    }
}
