package com.example.schedule.receiver;


import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import com.example.schedule.info.ScheduleInfo;
import com.example.schedule.service.AlarmService;
import com.example.schedule.util.ScheduleUtil;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.widget.Toast;
/**
 * A[sɌĂяo郌V[o[
 *
 */
public class ScheduleAlarmReceiver  extends BroadcastReceiver {
    //XPW[̋LqĂt@C
    public static final String SCHEDULE_LIST_FILE = "schedule_list.txt";
    /**
     * AlarmManagerPendingIntentŎs郌V[o[NX
     * XPW[t@Cɓo^Ă鎞Ԃƌݎ𔻒肵
     * Ώۂ̎ɂȂATEhĐAoCu[VT[rXN
     * 
     * @param    ctx    ReLXg
     * @param    intent    Ăяoꂽۂɒli[Ăintent
     */
    @Override
    public void onReceive(Context ctx, Intent intent) {
        try {
            //XPW[ꗗt@C烊Xg擾
            ArrayList<ScheduleInfo> scheduleList = ScheduleUtil.getScheduleList(ctx);
            
            //Xg[v
            for(int i = 0 ; i < scheduleList.size() ; i++){
                ScheduleInfo info = (ScheduleInfo)scheduleList.get(i);
                
                //ǂݍ񂾃Xgɓtݒ肳ĂAĂяotOTrue
                if(ScheduleUtil.chkDate(info.getSchedule()) && info.isCallFlag()){
                    //ݓtLonglŎ擾
                    long nowTime = Calendar.getInstance().getTimeInMillis();
                    
                    //XPW[ꗗt@C擾tLonglɕϊ
                    long timeMillion = getTimeMiilions(info.getSchedule());
                    
                    
                    long interval = 1 * 1000 * 30;
                    
                    //O30bAꕪȓȂN
                    if( (nowTime + interval) >= timeMillion && 
                            (nowTime - interval) <= timeMillion ){
                        //XPW[t@CɎw肳ꂽԂł΁AT[rXĂяo
                        //ScheduleUtil.registService(ctx,timeMillion);
                    	//Toast.makeText(ctx, "T[rX̋N", Toast.LENGTH_LONG).show();
                    	//XPW[t@CɎw肳ꂽԂł΁AT[rXĂяo
                        Intent alarmIntent=new Intent(ctx,AlarmService.class);
                        ctx.startService(alarmIntent);

                        //T[rXĂяo͌ĂяotOfalseɕύX
                        info.setCallFlag(false);
                        //XPW[t@Cɏo͂
                        ScheduleUtil.writeScheduleList(ctx,scheduleList);
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    /**
     * Date^̓tLong^̓tf[^擾
     * @param date@longɕϊtf[^
     * @return    longɕϊꂽtf[^
     */
    public static long getTimeMiilions(String date){
        //ttH[}bg𐶐
        DateFormat df = new SimpleDateFormat("yyyy/MM/dd hh:mm");
        Date d;
        try {
            //ttH[}bgDateݒ
            d = df.parse(date);
            Calendar calendar = Calendar.getInstance();
            calendar.setTime(d);
            //J_[longf[^擾ԋp
            return calendar.getTimeInMillis();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return 0;
    }
}
