package com.example.schedule.service;

import com.example.schedule.R;
import com.example.schedule.StopSchedule;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.IBinder;
import android.os.Vibrator;
import android.widget.Toast;

public class AlarmService extends Service {
    private MediaPlayer player;    //v[[
    Vibrator vibrator ; //oCu[^[
    private NotificationManager nm;//mbeBtBP[V}l[W
    /**
     * T[rX̋N
     */
    @Override
    public void onCreate() {
        try {
            //mbeBtBP[V}l[W̎擾
            nm=(NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);

            //oCu[^[̎擾
            vibrator = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
            
            //v[[̐
            player=MediaPlayer.create(this,R.raw.sample);
            //player.prepare();
            //vC[[vĐ
            player.setLooping(true);
        } catch (Exception e) {
            e.printStackTrace();
        }        
    }
    /**
     * T[rX̊Jn
     * @param intent	JnۂIntent
     * @param startID	T[rXʂID
     */
    @Override
    public void onStart(Intent intent,int startID) {
        try {
            //mbeBtBP[V̕\
            showNotification(this,R.drawable.icon,
                "XPW[N܂",
                "XPW[A[T[rX",
                "XPW[Jn܂");

            //oCu[^[̎s@1b~@2bU@3b~@4bUcc
            long[] pattern = {1000, 2000, 3000, 4000, 5000, 6000}; 
            vibrator.vibrate(pattern, -1);
            
            //vC[̍ĐʒuŏɎw
            player.seekTo(0);
            //vC[Đ
            player.start();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    /**
     * T[rXI
     */
    @Override
    public void onDestroy() {

        //mbeBtBP[ṼLZ
        nm.cancel(0);

        
        //TEh̒~щ
        player.stop();
        player.release();
        
        //g[Xg̕\
        Toast.makeText(this,"XPW[~܂",Toast.LENGTH_SHORT).show();
    }
    
    /**
     * oCh
     * @param intent 
     */
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }
    /**
     * mbeBtBP[V̕\
     * @param context	ReLXg
     * @param iconID	ACRID
     * @param ticker	ÑbZ[W
     * @param title	mbeBtBP[Ṽ^Cg
     * @param message	mbeBtBP[Vɕ\郁bZ[W
     */
    private void showNotification(Context context,
        int iconID,String ticker,String title,String message) {
        //mbeBtBP[VIuWFNg̐
        Notification notification=new Notification(iconID,ticker,System.currentTimeMillis());
        Intent intent = new Intent(context,StopSchedule.class);
        
        //^XNo[ŃNbNꂽƂ̕\ANeBreBw
        PendingIntent pIntent=PendingIntent.getActivity(context,0,intent,Intent.FLAG_ACTIVITY_NEW_TASK);
        
        notification.setLatestEventInfo(context,title,message,pIntent);
        
        //mbeBtBP[V̕\
        nm.notify(0,notification);
    }
}
