package com.example.rss.reader.activity;

import com.example.rss.reader.parser.RssParser;
import com.example.rss.reader.util.RssUtil;
import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;

/**
 * 
 * Rsso^
 * 
 * RssURLƁARss̎擾Ԋuo^ʂ\
 *
 */
public class RegistRssFeedActivity extends Activity implements OnClickListener{
    EditText rssFeed;    //RsstB[ho^eLXg
    Button rssAddBtn,clearBtn;    //ǉ{^ANA{^
    RadioButton oneHour,sixHour,twentyHour,oneDay;    //XVԊuWI{^
    RadioGroup rg;    //WI{^O[v
    /**
     * Rsso^ʂ̏\
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //ʃCAEg̍쐬 cɐݒ
        LinearLayout displayLayout = new LinearLayout(this);
        displayLayout.setOrientation(LinearLayout.VERTICAL);
        
        //RsstB[h̃CAEg ɐݒ
        LinearLayout feedLayout = new LinearLayout(this);
        feedLayout.setOrientation(LinearLayout.HORIZONTAL);

        //{^CAEg ɐݒ
        LinearLayout btnLayout = new LinearLayout(this);
        btnLayout.setOrientation(LinearLayout.HORIZONTAL);
        
        setContentView(displayLayout);

        
        //Url͍̓ڐ
        TextView Urltv = (new TextView(this));
        Urltv.setText("URL:");
        rssFeed = new EditText(this);
        //RsstB[hCAEgɐݒ
        feedLayout.addView(Urltv,RssUtil.createParam(RssUtil.WC, RssUtil.WC));
        feedLayout.addView(rssFeed,RssUtil.createParam(RssUtil.FP, RssUtil.WC));

        //XVԊũWI{^
        TextView radioTv = (new TextView(this));
        radioTv.setText("XVԊu");
        
        //XVԊu1Ԗ
        oneHour = new RadioButton(this);
        oneHour.setId(1);
        oneHour.setText("1Ԗ");

        //XVԊu6Ԗ
        sixHour = new RadioButton(this);
        sixHour.setId(6);
        sixHour.setText("6Ԗ");
        
        //XVԊu24Ԗ
        twentyHour = new RadioButton(this);
        twentyHour.setId(12);
        twentyHour.setText("12Ԗ");

        //XVԊu24Ԗ
        oneDay = new RadioButton(this);
        oneDay.setId(24);
        oneDay.setText("24Ԗ");
        
        //WIO[v̍쐬AWI{^̒ǉ        
        rg = new RadioGroup(this);
        rg.addView(oneHour);
        rg.addView(sixHour);
        rg.addView(twentyHour);
        rg.addView(oneDay);
        rg.check(1);
        rg.setLayoutParams(new LinearLayout.LayoutParams(RssUtil.WC, RssUtil.WC));
        
        //ǉ{^ANA{^̒ǉ
        rssAddBtn = new Button(this);
        rssAddBtn.setText("tB[h̒ǉ");
        rssAddBtn.setOnClickListener(this);
        
        clearBtn = new Button(this);
        clearBtn.setText("NA");
        clearBtn.setOnClickListener(this);
        
        //{^{^CAEgɒǉ
        btnLayout.addView(rssAddBtn,RssUtil.createParam(150, RssUtil.WC));
        btnLayout.addView(clearBtn,RssUtil.createParam(150, RssUtil.WC));
        
        //CAEgƃWI{^ʃCAEgɒǉ
        displayLayout.addView(feedLayout,RssUtil.createParam(RssUtil.FP, RssUtil.WC));
        displayLayout.addView(radioTv);
        displayLayout.addView(rg);
        displayLayout.addView(btnLayout,RssUtil.createParam(RssUtil.FP, RssUtil.WC));
    }
    /**
     * ǉANA{^̃CxgXi[
     * @param    view    ꂽ{^IuWFNg
     */
    @Override
    public void onClick(View view) {
        //RsstB[hǉ{^
        if(view == rssAddBtn){
            String rssUrl = rssFeed.getText().toString();
            
            //ID̏l
            int id = -1;
            //RsstB[h̍XVԊu擾
            int updHour = rg.getCheckedRadioButtonId();
            
            //RsstB[h̃wb_DB֊i[
            //DB֊i[AIDɎ擾ĂȂ΁ARsstB[h̋L擾
            if((id = RssParser.parseRssFeed(rssUrl,updHour)) >= 0){
                
                RssUtil.showToast(this,"RsstB[h̓o^ɐ܂BRec擾Ă܂B");
                
                //Rss̋Lǂݍ݃f[^x[X֓o^ 
                RssParser.parseRssContents(rssUrl, String.valueOf(id));
                
                RssUtil.showToast(this,"RssRec擾܂B");
                
                //ʂ̖߂lݒ
                setResult(RESULT_OK);
                
                //ʂ̏I
                finish();
            }else{
                RssUtil.showToast(this,"RsstB[h̓o^Ɏs܂Błɓo^Ă邩ARss2.0ɑΉĂ邩mFĂB");
            }
        //NA{^
        }else if(view == clearBtn){
            //RsstB[h̒lNA
            rssFeed.setText("");
        }
    }

    /**
     * ߂{^ɉʂI
     * @param keyCode    ꂽL[R[h
     * @param event    ꂽKeyEventIuWFNg
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        if(keyCode== KeyEvent.KEYCODE_BACK){
            //ʂ̖߂lݒ
            setResult(RESULT_OK);
            //ʂ̏I
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }
}
