package com.example.rss.reader.activity;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import com.example.rss.reader.R;
import com.example.rss.reader.parser.RssParser;
import com.example.rss.reader.provider.RssFeeds;
import com.example.rss.reader.util.RssUtil;
import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;

import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;
/**
 * 
 * RsstB[hL̕\
 * o^ꂽURLRss̒lXg\
 *
 */
public class RssArticleListActivity extends Activity implements OnClickListener,OnItemClickListener{
    
    //LɑΉUrli[}bvIuWFNg
    private HashMap<Long, String> urlMap = new HashMap<Long, String>();
    
    //L̈ꗗ\ListView
    private ListView articleListView ;
    
    //RsstB[h̍폜{^
    private Button deleteBtn;
    //RsstB[h̍Ď擾{^
    private Button reGetBtn;
    
    
    /**
     * RsstB[h\ʏ\
     */
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //ʃCAEg@cɐݒ
        LinearLayout displayLayout = new LinearLayout(this);
        displayLayout.setOrientation(LinearLayout.VERTICAL);
        
        //{^CAEg@ɐݒ
        LinearLayout btnLayout = new LinearLayout(this);
        btnLayout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(displayLayout);
        
        //RsstB[h̍폜{^
        deleteBtn = new Button(this);
        deleteBtn.setText("RsstB[h폜");
        deleteBtn.setOnClickListener(this);
        
        //RsstB[h̍Ď擾{^
        reGetBtn = new Button(this);
        reGetBtn.setText("RsstB[hĎ擾");
        reGetBtn.setOnClickListener(this);
        
        //{^CAEgɃ{^̒ǉ
        btnLayout.addView(deleteBtn,RssUtil.createParam(150, RssUtil.WC));
        btnLayout.addView(reGetBtn,RssUtil.createParam(150, RssUtil.WC));
        
        //LꗗListView̐
        articleListView  = new ListView(this);
        articleListView.setOnItemClickListener(this);
        getArrayAdapter();
        
        //{^CAEgƁALꗗListViewʃCAEgɒǉ
        displayLayout.addView(btnLayout);
        displayLayout.addView(articleListView);
    }
    /**
     * RsstB[ḧꗗ擾ListViewXV
     * @return ListAdapter
     */
    private void getArrayAdapter() {
        int listCnt = 0;
        Intent intent = getIntent();
        Bundle extras = intent.getExtras();
        
        //RsstB[hꗗʂIꂽtB[hID擾
        String rssId = (String) extras.get("id");
        
        //L擾ۂWhere̍쐬
        StringBuffer selection = new StringBuffer(RssFeeds.RssFeedContentsColumns.CHANNEL_ID )
            .append("=")
            .append(rssId);
        
        //ContentsProviderQuery𔭍sāARsstB[hꗗőIꂽRsstB[h
        //L̃J[\f[^x[X擾
        Cursor mRssCursor=RssFeeds.query(
                RssFeeds.RssFeedContentsColumns.CONTENT_URI,RssFeeds.RSSCONTENT_PROJECTION_MAP.keySet().toArray(new String[0]),
                selection.toString(),null,RssFeeds.RssFeedContentsColumns.DEFAULT_SORT_ORDER);
        
        List<String> adapterDataList = new LinkedList<String>();
        //RsstB[hŎ擾LJ[\[v
        while(mRssCursor.moveToNext()){
            //^CgJʒu擾A^Cg̒lf[^x[X擾
            int itemTitleCol     =mRssCursor.getColumnIndex(RssFeeds.RssFeedContentsColumns.ITEM_TITLE);
            String title = mRssCursor.getString(itemTitleCol);
            
            //L̉Jʒu擾AL̉̒lf[^x[X擾
            //int itemDescCol     =mRssCursor.getColumnIndex(RssFeeds.RssFeedContents.ITEM_DESCRIPTION);
            //String desc = mRssCursor.getString(itemDescCol);

            //LUrlJʒu擾ALUrl̒lf[^x[X擾
            int itemLinkCol     =mRssCursor.getColumnIndex(RssFeeds.RssFeedContentsColumns.ITEM_LINK);
            String link = mRssCursor.getString(itemLinkCol);

            //L̍XVJʒu擾AL̂̍XV̒lf[^x[X擾
            int pubDateCol     =mRssCursor.getColumnIndex(RssFeeds.RssFeedContentsColumns.PUB_DATE);
            String pubDate = mRssCursor.getString(pubDateCol);

            //Lꗗɕ\ef[^x[X擾lō쐬
            //L̃^CgƁAXV\
            adapterDataList.add(//guid  + System.getProperty("line.separator") + "\t" + 
                        title + System.getProperty("line.separator")
                        + pubDate
                        //+ System.getProperty("line.separator") 
                        //+ link + System.getProperty("line.separator") + "\t" + 
                        //+ System.getProperty("line.separator") + desc
                        );
            //Lꗗ̑IꂽʒuƁALURL}bvIuWFNgɊi[
            //ListViewŋLIꂽʒulong^Ŏ擾̂Long^Ŋi[
            urlMap.put(new Long(listCnt),link);
            listCnt++;
        }
        //ListStringzɕϊ
        String[] data = (String[]) adapterDataList.toArray(new String[0]); 
        
        //Lꗗf[^x[X擾lōXV
        articleListView.setAdapter(new ArrayAdapter<String>(this, R.layout.rsslistlayout, data));
    }

    /**
     * {^̃CxgXi[
     * @param    view    ꂽ{^IuWFNg
     */
    @Override
    public void onClick(View view) {
        Intent intent = getIntent();
        Bundle extrs = intent.getExtras();
        
        //RsstB[hꗗʂIꂽARsstB[hID擾
        String rssId = (String) extrs.get("id");
        //폜{^
        if(view == deleteBtn){
            //RssFeedContentse[uւDeleteWhere̍쐬
            //RssFeedContentse[uchannnel_idIꂽRsstB[hIDƈv̂폜
            StringBuffer whereRssFeedContents = new StringBuffer(RssFeeds.RssFeedContentsColumns.CHANNEL_ID )
                .append("=")
                .append(rssId);
            
            //RssL̍폜f[^x[XɎs
            RssFeeds.delete(RssFeeds.RssFeedContentsColumns.CONTENT_URI, whereRssFeedContents.toString(), null);
            
            //RssFeedse[uID폜Where쐬
            //RssFeedse[u_idIꂽRsstB[hIDƈv̂폜
            StringBuffer whereRssFeeds = new StringBuffer(RssFeeds.RssFeedsColumns._ID )
                .append("=")
                .append(rssId);
            
            //RsstB[h̍폜f[^x[XɎs
            RssFeeds.delete(RssFeeds.RssFeedsColumns.CONTENT_URI, whereRssFeeds.toString(), null);
            
            //ʂ̖߂lݒ
            setResult(RESULT_OK);
            
            //ʏI
            finish();
        }else if(view == reGetBtn){ 
            //RsstB[h̍Ď擾{^
            
            //RsstB[hꗗʂőIꂽRsstB[hURL擾
            String url = (String) extrs.get("url");

            //Contents폜
            StringBuffer whereRssFeedContents = new StringBuffer(RssFeeds.RssFeedContentsColumns.CHANNEL_ID )
                .append("=")
                    .append(rssId);
            //RssFeedContentse[uIꂽRsstB[hID폜
            RssFeeds.delete(RssFeeds.RssFeedContentsColumns.CONTENT_URI, whereRssFeedContents.toString(), null);
            
            //IꂽRsstB[hURLēxRsstB[h̒l擾f[^x[X֊i[
            RssParser.parseRssContents(url, rssId);
            
            //f[^x[XLꗗ̒l擾ALꗗListViewXV
            getArrayAdapter();
        }
    }

    /**
     * ListView̋L̃CxgXi[
      * @param    view    ꂽXgr[
      * @param    view    Xgr[őIꂽXgr[̃r[IuWFNg
      * @param    position    IꂽXgr[̈ʒu
      * @param    id    ID
     */
    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position,long id) {
        //ꂽListViewLꗗListView
        if(parent == articleListView){
            
            //ListView쐬ɍ쐬}bvIuWFNgIDL[ɂċLUrl̎擾
            String url = (String) urlMap.get(new Long(id));
       
            //L̕\ANeBreB̎w
            Intent intent = new Intent(this,RssArticleActivity.class);
            //\ANeBreBݒ
            intent.putExtra("url", url);
            //ANeBreB̌Ăяo
            startActivityForResult(intent,0);
        }
    }
    /**
     * ߂{^ɉʂ̏I
     * @param    keyCode    ꂽL[R[h
     * @param    event    ꂽL[Cxg
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event){
        //߂{^́Aʖ߂lOKݒ肵ĉʂI
        if (keyCode==KeyEvent.KEYCODE_BACK) {
            setResult(RESULT_OK); 
            finish();
        }
        return super.onKeyDown(keyCode, event);
    }
}
