package com.example.google.map;


import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.location.LocationProvider;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.Window;
import android.widget.Toast;
/**
 * GoogleMaps\AvP[V
 *
 */
public class AndroidGoogleMaps extends MapActivity implements LocationListener{
	private  MapView mapView;					//}bvr[
	private LocationManager locationManager;	//P[V}l[W

	private static final int M_ZOOMIN = Menu.FIRST + 1;		//Y[C
	private static final int M_ZOOMOUT = Menu.FIRST + 2;	//Y[AEg
	private static final int M_SATELLITE = Menu.FIRST + 3;	//qʐ^[hؑ
	private static final int M_NOW_LOCATION = Menu.FIRST + 4;	//ݒn̕\
	private static final int M_KOKKAI_GIJIDOU = Menu.FIRST + 5;	//c̕\
	private static final int M_HIMEJI = Menu.FIRST + 6;			//PH̕\
	private GeoPoint nowlocation;	//ݒn
	
	/**
	 * NɎs
	 */
	@Override
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		//AvP[Ṽ^Cgo[\ɐݒ
		requestWindowFeature(Window.FEATURE_NO_TITLE );
		//Mapr[̐
		//J
		//mapView=new MapView(this,"Develop APi Key");
		//[X
		mapView=new MapView(this,"your api key");
		//GoogleMapł̃hbOAhbv
		mapView.setClickable(true);
		//gk{^̕\
		mapView.setBuiltInZoomControls(true);
		setContentView(mapView);
		
		//LocationManager擾
		locationManager = (LocationManager)this.getSystemService(Context.LOCATION_SERVICE);
		
		//݈ʒu擾XV
		locationManager.requestLocationUpdates(
				LocationManager.GPS_PROVIDER,	   //擾łȂꍇ
				//LocationManager.NETWORK_PROVIDER, //擾łȂꍇ
				0 , 0, this);
		
	}
	@Override
	 protected boolean isRouteDisplayed() {
		return false;
	}
	/**
	 * j[{^̒ǉ
	 * @param	menu	j[IuWFNg
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(Menu.NONE, M_ZOOMIN,Menu.NONE, "Y[C");
		menu.add(Menu.NONE, M_ZOOMOUT,Menu.NONE, "Y[AEg");
		menu.add(Menu.NONE, M_SATELLITE,Menu.NONE, "qʐ^[hؑ");
		menu.add(Menu.NONE, M_NOW_LOCATION, Menu.NONE,"ݒn\");
		menu.add(Menu.NONE, M_KOKKAI_GIJIDOU,Menu.NONE, "c");
		menu.add(Menu.NONE, M_HIMEJI,Menu.NONE, "PH");

		return super.onCreateOptionsMenu(menu);
	}
	/**
	 * j[̑ĨCxg
	 * @param	item	Iꂽj[{^
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		MapController mc = mapView.getController();

		int ido = 0;
		int keido = 0;
		switch (item.getItemId()) {
		//Y[C
		case M_ZOOMIN:
			mc.setZoom(mapView.getZoomLevel() + 1);
			return true;
		//Y[AEg	
		case M_ZOOMOUT:
			mc.setZoom(mapView.getZoomLevel() - 1);
			return true;
		//qʐ^[hւ̐ؑ
		case M_SATELLITE:
			mapView.setSatellite(!mapView.isSatellite());
			return true;
		//݈ʒu擾ړ	  
		case M_NOW_LOCATION:
			//̋ʒuiܓxAoxj擾
			Location location = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
			if(location == null){
				location = locationManager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
			}
			if(location != null){
				ido = (int)(location.getLatitude()*1E6) ;
				keido = (int)(location.getLongitude()*1E6) ;
				mc.animateTo(new GeoPoint(ido,keido));
			}else if(nowlocation != null){
				mc.animateTo(nowlocation);
			}else{
				Toast.makeText(this, "݂̈ʒu񂪎擾ł܂łBGps@\ONɂȂĂ邩A΂炭ĂsĂB", Toast.LENGTH_LONG).show();
			}
			return true;
		//c\
		case M_KOKKAI_GIJIDOU:
			ido = (int)(35.675911 * 1E6);
			keido = (int)(139.745042 * 1E6);
			mc.animateTo(new GeoPoint(ido,keido));
			mc.setZoom(15);
			if(!mapView.isSatellite()) {
				mapView.setSatellite(!mapView.isSatellite());
			}
			return true;
		//PH\
		case M_HIMEJI:
			ido =  (int)(34.838113 * 1E6);
			keido =  (int)(134.692755 * 1E6);
			mc.animateTo(new GeoPoint(ido,keido));
			mc.setZoom(15);
			if(!mapView.isSatellite()) {
				mapView.setSatellite(!mapView.isSatellite());
			}
			return true;
		}
	  return false;
	}
	/**
	 * ʒu񂪍XṼCxg
	 * @param	location	P[VIuWFNg
	 */
	@Override
	public void onLocationChanged(Location location) {
		nowlocation = 
			new GeoPoint((int)(location.getLatitude()*1E6),
				         (int)(location.getLongitude()*1E6));

	}
	/**
	 * voC_gp\ȏ
	 */
	@Override
	public void onProviderDisabled(String provider) {
		
	}
	/**
	 * voC_gps̏
	 */
	@Override
	public void onProviderEnabled(String provider) {
	}
	/**
	 * voC_̏Ԃωꍇ
	 */
	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		switch (status) {
		case LocationProvider.AVAILABLE:
			//voC_s\̏Lq
			break;
		case LocationProvider.OUT_OF_SERVICE:
			//voC_ss̏Lq
			break;
		case LocationProvider.TEMPORARILY_UNAVAILABLE:
			//e|擾łȂ
			break;
		}

	}
}