package com.example.sensor;

import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.widget.TextView;

public class SensorActivity extends Activity implements SensorEventListener {
	private SensorManager sensorManager;	//ZT[}l[W
	private Sensor		accelerometer;		//xT[
	private Sensor		orientation; 		//]T[
	private Sensor		temperature; 		//xT[
	
	TextView xText;					//X̉xText
	TextView xSensor;				//X̉xim/sj
	TextView yText;					//ỶxText
	TextView ySensor;				//Ỷxim/sj
	TextView zText;					//Z̉xText
	TextView zSensor;				//Z̉xim/sj
	
	TextView azimuthText;			//Text
	TextView azimuthSensor;			//
	TextView pitchText;				//sb`Text
	TextView pitchSensor;			//sb`
	TextView rollText;				//[Text
	TextView rollSensor;			//[
	
	TextView temperatureText;		//xText
	TextView temperatureSensor;		//x

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //CAEg̐ݒ
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        LinearLayout horiLayout1 = new LinearLayout(this);
        horiLayout1.setOrientation(LinearLayout.HORIZONTAL);
        LinearLayout horiLayout2 = new LinearLayout(this);
        horiLayout2.setOrientation(LinearLayout.HORIZONTAL);
        LinearLayout horiLayout3 = new LinearLayout(this);
        horiLayout3.setOrientation(LinearLayout.HORIZONTAL);
        LinearLayout horiLayout4 = new LinearLayout(this);
        horiLayout4.setOrientation(LinearLayout.HORIZONTAL);
        LinearLayout horiLayout5 = new LinearLayout(this);
        horiLayout5.setOrientation(LinearLayout.HORIZONTAL);
        LinearLayout horiLayout6 = new LinearLayout(this);
        horiLayout6.setOrientation(LinearLayout.HORIZONTAL);
        LinearLayout horiLayout7 = new LinearLayout(this);
        horiLayout7.setOrientation(LinearLayout.HORIZONTAL);

        layout.addView(horiLayout1);
        layout.addView(horiLayout2);
        layout.addView(horiLayout3);
        layout.addView(horiLayout4);
        layout.addView(horiLayout5);
        layout.addView(horiLayout6);
        layout.addView(horiLayout7);
        
        setContentView(layout);
        
        xText = new TextView(this);				//X̉xText
        xSensor = new TextView(this);			//X̉xim/sj
        yText = new TextView(this);				//ỶxText
        ySensor = new TextView(this);			//Ỷxim/sj
        zText = new TextView(this);				//Z̉xText
        zSensor = new TextView(this);			//Z̉xim/sj
        azimuthText = new TextView(this);		//Text
        azimuthSensor = new TextView(this);		//
        pitchText = new TextView(this);			//sb`Text
        pitchSensor = new TextView(this);		//sb`
        rollText = new TextView(this);			//[Text
        rollSensor = new TextView(this);		//[
        
        temperatureSensor = new TextView(this);	//xText
        temperatureText = new TextView(this);	//x
        
        
        xText.setText("XxF");
        yText.setText("YxF");
        zText.setText("ZxF");
        
        azimuthText.setText("ʁF");
        pitchText.setText("sb`F");
        rollText.setText("[F");

        temperatureText.setText("xF");

        horiLayout1.addView(xText);
        horiLayout1.addView(xSensor);
        horiLayout2.addView(yText);
        horiLayout2.addView(ySensor);
        horiLayout3.addView(zText);
        horiLayout3.addView(zSensor);
        
        horiLayout4.addView(azimuthText);
        horiLayout4.addView(azimuthSensor);
        horiLayout5.addView(pitchText);
        horiLayout5.addView(pitchSensor);
        horiLayout6.addView(rollText);
        horiLayout6.addView(rollSensor);

        horiLayout7.addView(temperatureText);
        horiLayout7.addView(temperatureSensor);
        
        //ZT[}l[W̎擾
		sensorManager=(SensorManager)getSystemService(
			Context.SENSOR_SERVICE);
		
		
		//ZT[̎擾
		List<Sensor> list;
		//xZT[
		list=sensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
		if (list.size()>0) {
			accelerometer=list.get(0);
		}
		//XZT[
		list=sensorManager.getSensorList(Sensor.TYPE_ORIENTATION);
		if (list.size()>0){
			orientation=list.get(0);
		}
		//xZT[
		list=sensorManager.getSensorList(Sensor.TYPE_TEMPERATURE);
		if (list.size()>0){
			temperature=list.get(0);
		}
		//ZT[̏̊Jn
		//XZT[̊Jn
		if (accelerometer!=null) {
			sensorManager.registerListener(this, 
				accelerometer,SensorManager.SENSOR_DELAY_UI);
		}
		//XZT[̊Jn
		if (orientation!=null) {
			sensorManager.registerListener(this, 
	  			orientation,SensorManager.SENSOR_DELAY_UI);
		}
		//xZT[̊Jn
		if (temperature!=null) {
			sensorManager.registerListener(this, 
				temperature,SensorManager.SENSOR_DELAY_UI);
		}
    }

	@Override
	public void onAccuracyChanged(Sensor sensor, int i) {
	}
	/**
	 * ZT[Xi[̏
	 * @param	sensorevent	ZT[Cxg
	 */
	@Override
	public void onSensorChanged(SensorEvent sensorevent) {
		
		//xZT[
		if(sensorevent.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
			xSensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_X]));
			ySensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_Y]));
			zSensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_Z]));
		//XZT[
		}else if(sensorevent.sensor.getType() == Sensor.TYPE_ORIENTATION) {
			azimuthSensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_X]));
			pitchSensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_Y]));
			rollSensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_Z]));
		//xZT[
		}else if (sensorevent.sensor.getType() == Sensor.TYPE_TEMPERATURE) {
			temperatureSensor.setText(String.valueOf(sensorevent.values[SensorManager.DATA_X]));
		}

		
	}
}