package com.example.texttospeech;

import android.app.Activity;
import android.media.AudioManager;
import android.os.Bundle;

import java.util.HashMap;
import java.util.Locale;

import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnUtteranceCompletedListener;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Toast;
import android.widget.RadioGroup.OnCheckedChangeListener;
/**
 * ̓eLXgo͂
 *
 */
public class TextSpeechActivity extends Activity 
							implements OnUtteranceCompletedListener,
							OnCheckedChangeListener,
							OnClickListener,
							TextToSpeech.OnInitListener {

	//ʂɔzuIuWFNg̃CAEgp[^
    public final static int FP = ViewGroup.LayoutParams.FILL_PARENT;
    public final static int WC = ViewGroup.LayoutParams.WRAP_CONTENT;
    
    //eLXgXs[`Ip[^
    private static final String SPEECH_FINISHED ="speechFinished";
    
    private EditText speechText;	//Xs[`eLXg̓eLXg
    private Button btnspeech;	//Xs[`{^
    private Button btnClear;	//Xs[`eLXgNA{^
    private Button btnOther;	//̑̃{^
    private TextToSpeech tts;	//eLXgXs[`

    private  final int LOCAL_ENGLISH = 1;	//P[p𔻒肷萔
    private  final int LOCAL_FRENCH = 2;	//P[tX𔻒肷萔
    private  final int LOCAL_GERMAN = 3;	//P[hCc𔻒肷萔
    private  final int LOCAL_ITALIAN = 4;	//P[C^A𔻒肷萔
    private  final int LOCAL_SAPIN = 5;		//P[XyC𔻒肷萔
    private  final int LOCAL_JAPANESE = 6;	//P[{𔻒肷萔
    
    RadioButton rbEnglish;	//WI{^p
    RadioButton rbFrench ;	//WI{^tX
    RadioButton rbGermany;	//WI{^hCc
    RadioButton rbItalian;	//WI{^C^A
    RadioButton rbSpain;	//WI{^XyC
    RadioButton rbJapanese;	//WI{^{
    RadioGroup rg;	//WI{^O[v
    /**
     * ANeBreB쐬Ɏs
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //ʃCAEg̐
        LinearLayout displayLayout = new LinearLayout(this);
        displayLayout.setOrientation(LinearLayout.VERTICAL);
        
        
        setContentView(displayLayout);
        
        //eLXgXs[`EditText̐
        speechText = new EditText(this);
        
        //pAtXAhCcAC^AAXyCA{̃WI{^
        rbEnglish = new RadioButton(this);
        rbEnglish.setText("p");
        rbEnglish.setId(LOCAL_ENGLISH);
        
        rbFrench = new RadioButton(this);
        rbFrench.setText("tX");
        rbFrench.setId(LOCAL_FRENCH);
        
        rbGermany = new RadioButton(this);
        rbGermany.setText("hCc");
        rbGermany.setId(LOCAL_GERMAN);

        rbItalian = new RadioButton(this);
        rbItalian.setText("C^A");
        rbItalian.setId(LOCAL_ITALIAN);        

        rbSpain = new RadioButton(this);
        rbSpain.setText("XyC");
        rbSpain.setId(LOCAL_SAPIN);        

        rbJapanese = new RadioButton(this);
        rbJapanese.setText("{");
        rbJapanese.setId(LOCAL_JAPANESE);
        
        //WI{^WIO[vɐݒ
        rg = new RadioGroup(this);
        rg.addView(rbEnglish);
        rg.addView(rbFrench);
        rg.addView(rbGermany);
        rg.addView(rbItalian);
        rg.addView(rbSpain);
        rg.addView(rbJapanese);
        
        //WI{^`FbNɎsCxgXi[
        rg.setOnCheckedChangeListener(this);
        
        //Xs[`{^
        btnspeech = new Button(this);
        btnspeech.setText("Xs[`");
        btnspeech.setOnClickListener(this);
        btnspeech.setEnabled(false);
        
        //NA{^
        btnClear = new Button(this);
        btnClear.setText("NA");
        btnClear.setOnClickListener(this);
        
        //̑̃Xs[`
        btnOther = new Button(this);
        btnOther.setText("̑̃Xs[`");
        btnOther.setOnClickListener(this);
        btnOther.setEnabled(false);

        //{^CAEg̐
        LinearLayout btnLayout = new LinearLayout(this);
        btnLayout.setOrientation(LinearLayout.HORIZONTAL);
        
        //e{^{^CAEgɐݒ
        btnLayout.addView(btnspeech,createParam(WC,WC));
        btnLayout.addView(btnClear,createParam(WC,WC));
        btnLayout.addView(btnOther,createParam(WC,WC));
        
        //ʃCAEgɃeLXgXs[`AWIO[vA{^CAEg̐ݒ
        displayLayout.addView(speechText);
        displayLayout.addView(rg);
        displayLayout.addView(btnLayout);

        //eLXgXs[`̐
        tts = new TextToSpeech(this, this);
    }
    /**
     * @param	status	eLXgXs[`̏IɌĂяo<br/>	
     * 		TextToSpeech.SUCCESS	ɋN
     * 		TextToSpeech.ERROR		ُN
     */
    @Override
    public void onInit(int status) {
		if (status == TextToSpeech.SUCCESS) {
			Toast.makeText(this, "eLXgXs[`ɋN܂B", Toast.LENGTH_SHORT).show();
		}else{
			Toast.makeText(this, "eLXgXs[`NɎs܂BAvP[VI܂B", Toast.LENGTH_LONG).show();
			finish();
		}
    }
	/**
	 * WI{^̃CxgXi[
	 * @parama	radiogroup	ꂽWIO[v
	 * @parama	i	IꂽWI{^ID
	 */
	@Override
	public void onCheckedChanged(RadioGroup radiogroup, int i) {
		if(radiogroup == rg){
			Locale locale = null;
            
			switch(i){
			case LOCAL_ENGLISH://p
				locale = Locale.ENGLISH;
				break;
			case LOCAL_FRENCH ://tX
				locale = Locale.FRENCH;
				break;
			case LOCAL_GERMAN://hCc
				locale = Locale.GERMAN;
				break;
			case LOCAL_ITALIAN://C^A
				locale = Locale.ITALIAN;
				break;
			case LOCAL_SAPIN: //XyC
				locale = new Locale("spa", "ESP");
			 break;
			case LOCAL_JAPANESE: //{
				locale = Locale.JAPANESE;
			 break;
			}
			//IꂽP[eLXgXs[`ŗp\`FbN
			if(checkLocale(locale)){
				//p\Ȃ{^\
				btnspeech.setEnabled(true);
				btnOther.setEnabled(true);
			}else{
				//P[psȂ{^s
				btnspeech.setEnabled(false);
				btnOther.setEnabled(false);
				Toast.makeText(this, "Iꂽ̓T|[gĂ܂", Toast.LENGTH_SHORT).show();
			}
		}
	}
	/**
	 * P[gp\`FbN
	 * @param locale	eLXgXs[`𗘗p郍P[
	 * @return	trueFgp\	false:gps
	 */
	private boolean checkLocale(Locale locale){
		boolean ret = false;
		//P[eLXgXs[`őΉĂ邩`FbN
        if (tts.isLanguageAvailable(locale) >= TextToSpeech.LANG_AVAILABLE) {
        	//eLXgXs[`ɃP[ݒ
            tts.setLanguage(locale);
            ret = true;
        }
        return ret;
	}
    /**
     * {^̃CxgXi[
     * @param	view	ꂽ{^IuWFNg
     */
	@Override
	public void onClick(View view) {
		//Xs[`{^
		if(view == btnspeech){
			//eLXgXs[`̒lłȂ
            String strspeech = speechText.getText().toString();
            if (strspeech != null && !strspeech.equals("")) {
            	//eLXgXs[`sȂ
                if (tts.isSpeaking()) {
                	//seLXgXs[`~
                    tts.stop();
                }
                //eLXgXs[`̒lŃXs[`s
                tts.speak(strspeech, TextToSpeech.QUEUE_FLUSH, null);
            }
		}else if(view == btnClear){
			//eLXgXs[`̒lNA
            speechText.setText("");
		}else if(view == btnOther){
			//Œ̕
			String myText1 = "Did you sleep well?";
			String myText2 = "I hope so, because it's time to wake up.";
			

			//ICxgXi[ݒ
			tts.setOnUtteranceCompletedListener(this);
			
			//eLXgXs[`̃p[^ݒ}bvIuWFNg
			HashMap<String, String> myHashAlarm = new HashMap<String, String>();
			//A[ʂŃXs[`s
			myHashAlarm.put(TextToSpeech.Engine.KEY_PARAM_STREAM,String.valueOf(AudioManager.STREAM_ALARM));
			//myText1Xs[`
			tts.speak(myText1, TextToSpeech.QUEUE_FLUSH, myHashAlarm);
			
			//Ĩp[^ݒ
			myHashAlarm.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID,SPEECH_FINISHED);
			//myText2Xs[`
			tts.speak(myText2, TextToSpeech.QUEUE_FLUSH, myHashAlarm);
			
			
		}
	}
	/**
	 * eLXgXs[`ĨCxgXi[
	 * @param s	I
	 */
	@Override
	public void onUtteranceCompleted(String s) {
	    if (s.equals(SPEECH_FINISHED)) {
	    	Toast.makeText(TextSpeechActivity.this, "eLXgXs[`I܂", Toast.LENGTH_SHORT).show();
	    } 
	}
    /**
     * ʔjɌĂяo
     */
    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (tts != null) {
        	//eLXgXs[`I
            tts.shutdown();
        }
    }
    /**
     * CAEgp[^̎擾
     * @param w        width CAEgp^̉w
     * @param h        heigth CAEgp^̏cw
     * @return	CAEgp[^
     */
    public static LinearLayout.LayoutParams createParam(int w, int h){
        return new LinearLayout.LayoutParams(w, h);
    }
} 