package com.example.fragment;

import com.example.fragment.R;
import com.example.fragment.menu.MenuBar;
import com.example.fragment.menu.MenuCategory;

import android.app.ListFragment;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;

/**
 * 
 * TChj[̍쐬Aj[̋LqB
 *
 */
public class TitlesFragment extends ListFragment {
	//̃^uj[̉ʒu
    private int mCategory = 0;
    //j[̉ʒu
    private int mCurPosition = 0;

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        //j[̍쐬
        createMenuTitles(mCategory);
        
        ListView lv = getListView();
        //I𒆂̃j[̐FύX
        lv.setChoiceMode(ListView.CHOICE_MODE_SINGLE);

        
        //j[̏ʒuw
        initMenu(mCurPosition);
    }
    /**
     * j[̍쐬
     * @param category	j[̃JeS[w
     */
    public void createMenuTitles(int category) {
    	MenuCategory cat = MenuBar.getCategory(category);
        String[] items = new String[cat.getEntryCount()];
        for (int i = 0; i < cat.getEntryCount(); i++){
            items[i] = cat.getEntry(i).getName();
        }
        setListAdapter(new ArrayAdapter<String>(getActivity(),
                R.layout.title_list_item, items));
        mCategory = category;
    }
    /**
     * j[ɌĂяo
     */
    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        updateContentFragment(position);
    }
    /**
     * ContentFragment̍XV
     * @param position@j[̉ʒu
     */
    private void updateContentFragment(int position) {
    	//ContentFragment̎擾
        ContentFragment frag = (ContentFragment) getFragmentManager()
                .findFragmentById(R.id.frag_content);
        frag.updateContentAndRecycleView(mCategory, position);
        mCurPosition = position;
    }
    /**
     * j[̏s
     * ^uƃANeBreB쐬̃j[\ɌĂяo
     * @param position	j[̏ʒu
     */
    public void initMenu(int position) {
        ListView lv = getListView();
        lv.setItemChecked(position, true);
        updateContentFragment(position);
    }
}
