package com.example.rss.reader.provider;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

/**
 * DB̍쐬AсAXVǗs
 *
 */
public  class RSSFeedDBHelper extends SQLiteOpenHelper{
    /**
     * RXgN^
     * @param ctx ReLXg
     */
    public RSSFeedDBHelper(Context ctx) {
        super(ctx, RssFeeds.DATABASE_NAME, null, RssFeeds.DATABASE_VERSION);
    }
    /**
     * DBւ̃e[u쐬
     */
    @Override
    public void onCreate(SQLiteDatabase db) {
        //RsstB[he[u̍쐬
        db.execSQL("CREATE TABLE rssfeeds("+
            RssFeeds.RssFeedsColumns._ID +" INTEGER  PRIMARY KEY,"+
            RssFeeds.RssFeedsColumns._COUNT+" INTEGER,"+
            RssFeeds.RssFeedsColumns.CHANNEL_LINK+" "+RssFeeds.RssFeedsColumns.CHANNEL_LINK_TYPE+","+
            RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK+" "+RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK_TYPE+","+
            RssFeeds.RssFeedsColumns.CHANNEL_NAME+" "+RssFeeds.RssFeedsColumns.CHANNEL_NAME_TYPE+","+
            RssFeeds.RssFeedsColumns.CHANNEL_DESC+" "+RssFeeds.RssFeedsColumns.CHANNEL_DESC_TYPE+","+
            RssFeeds.RssFeedsColumns.CHANNEL_LANG+" "+RssFeeds.RssFeedsColumns.CHANNEL_LANG_TYPE+","+
            RssFeeds.RssFeedsColumns.UPDATE_CYCLE+" "+RssFeeds.RssFeedsColumns.UPDATE_CYCLE_TYPE+","+
            RssFeeds.RssFeedsColumns.LAST_UPDATE+" "+RssFeeds.RssFeedsColumns.LAST_UPDATE_TYPE +
            ");"
        );

        //RsstB[hRece[u̍쐬
        db.execSQL("CREATE TABLE rssfeedcontents("+
            RssFeeds.RssFeedContentsColumns._ID +" INTEGER,"+
            RssFeeds.RssFeedContentsColumns._COUNT+" INTEGER,"+
            RssFeeds.RssFeedContentsColumns.CHANNEL_ID+" "+RssFeeds.RssFeedContentsColumns.CHANNEL_ID_TYPE+","+
            RssFeeds.RssFeedContentsColumns.ITEM_TITLE+" "+RssFeeds.RssFeedContentsColumns.ITEM_TITLE_TYPE+","+
            RssFeeds.RssFeedContentsColumns.ITEM_AUTHOR+" "+RssFeeds.RssFeedContentsColumns.ITEM_AUTHOR_TYPE+","+
            RssFeeds.RssFeedContentsColumns.ITEM_LINK+" "+RssFeeds.RssFeedContentsColumns.ITEM_LINK_TYPE+","+
            RssFeeds.RssFeedContentsColumns.ITEM_DESCRIPTION+" "+RssFeeds.RssFeedContentsColumns.ITEM_DESCRIPTION_TYPE+ "," +
            RssFeeds.RssFeedContentsColumns.PUB_DATE+" "+RssFeeds.RssFeedContentsColumns.PUB_DATE_TYPE+ "," +
            "PRIMARY KEY("  + RssFeeds.RssFeedContentsColumns._ID + ")"+
            ");"
        );
    }
    /**
     * DB̍XV
     */
    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE rssfeeds;");
        db.execSQL("DROP TABLE rssfeedcontents;");
    }
}
