package com.example.rss.reader.provider;

import java.util.HashMap;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.database.Cursor;
import android.net.Uri;
import android.provider.BaseColumns;
/**
 * DB̒`ێNX
 * RssProviderĂяoADB̏s
 *
 */
public abstract class RssFeeds {
    /**
     * DBt@C
     */
    public static final String DATABASE_NAME="rssfeeds.db";
    /**
     * DB̃o[W
     */
    public static final int DATABASE_VERSION=1;
    /**
     * 
     * DBFRssFeedse[u̒`NX
     *
     */
    public static final class RssFeedsColumns implements BaseColumns{
        
        //RssFeedse[uUri
        public static final Uri CONTENT_URI= Uri.parse("content://com.example.rss.reader/rss");

        //RssFeedse[u̍    `lLink
        public static final String CHANNEL_LINK="channel_link";
        public static final String CHANNEL_LINK_TYPE="VARCHAR";

        //RssFeedse[u̍    `ltB[hLink
        public static final String CHANNEL_FEEDS_LINK="channel_feeds_link";
        public static final String CHANNEL_FEEDS_LINK_TYPE="VARCHAR";

        //RssFeedse[u̍    `ltB[h
        public static final String CHANNEL_NAME="channel_name";
        public static final String CHANNEL_NAME_TYPE="VARCHAR";

        //RssFeedse[u̍    XVTCN
        public static final String UPDATE_CYCLE="update_cycle";
        public static final String UPDATE_CYCLE_TYPE="INTEGER";

        //RssFeedse[u̍    ŏIXV
        public static final String LAST_UPDATE="last_upd";
        public static final String LAST_UPDATE_TYPE="INTEGER";

        //RssFeedse[u̍    RsstB[ȟ
        public static final String CHANNEL_LANG="channel_lang";
        public static final String CHANNEL_LANG_TYPE="VARCHAR";

        //RssFeedse[u̍    RsstB[h̉
        public static final String CHANNEL_DESC="channel_desc";
        public static final String CHANNEL_DESC_TYPE="TEXT";

        //RssFeedse[ũ\[gJ@_ID
        public static final String DEFAULT_SORT_ORDER = _ID;

    }

    /**
     * 
     * DBFRssFeedContentse[u̒`NX
     *
     */
    public static final class RssFeedContentsColumns implements BaseColumns{
        //RssFeedContentsUri
        public static final Uri CONTENT_URI= Uri.parse("content://com.example.rss.reader/rsscontents");
        

        //RssFeedContentse[u̍    `lIDi=RssFeeds._IDj
        public static final String CHANNEL_ID="channel_id";
        public static final String CHANNEL_ID_TYPE="INTEGER";

        //RssFeedContentse[u̍    LURL
        public static final String ITEM_LINK="item_link";
        public static final String ITEM_LINK_TYPE="VARCHAR";

        //RssFeedContentse[u̍    L̉
        public static final String ITEM_DESCRIPTION="item_desc";
        public static final String ITEM_DESCRIPTION_TYPE="TEXT";

        //RssFeedContentse[u̍    L̃^Cg
        public static final String ITEM_TITLE="item_title";
        public static final String ITEM_TITLE_TYPE="VARCHAR";

        //RssFeedContentse[u̍    L̍쐬
        public static final String ITEM_AUTHOR="item_author";
        public static final String ITEM_AUTHOR_TYPE="VARCHAR";
        
        //RssFeedContentse[u̍    L̍XVt
        public static final String PUB_DATE="pub_date";
        public static final String PUB_DATE_TYPE="VARCHAR";
        
        

        //RssFeedContentse[ũ\[gځ@L̍XVt
        public static final String DEFAULT_SORT_ORDER = PUB_DATE + " desc";
    }
    /**
     * NG𔭍sۂɎ擾e[uڂ̃}bvIuWFNg
     * Select field1,field2,field3 from XXX_table
     * field1`3}bvIuWFNgŊi[Ă
     */
    public static final HashMap<String,String> RSSFEED_PROJECTION_MAP;
    public static final HashMap<String,String> RSSCONTENT_PROJECTION_MAP;
    static{
        //RssFeedse[u̍ږƑ̃}bsO
        RSSFEED_PROJECTION_MAP=new HashMap<String,String>();
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns._ID, RssFeeds.RssFeedsColumns._ID);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns._COUNT,RssFeeds.RssFeedsColumns._COUNT);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.CHANNEL_NAME,RssFeeds.RssFeedsColumns.CHANNEL_NAME);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.CHANNEL_LINK,RssFeeds.RssFeedsColumns.CHANNEL_LINK);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK,RssFeeds.RssFeedsColumns.CHANNEL_FEEDS_LINK);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.CHANNEL_DESC,RssFeeds.RssFeedsColumns.CHANNEL_DESC);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.CHANNEL_LANG,RssFeeds.RssFeedsColumns.CHANNEL_LANG);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.UPDATE_CYCLE,RssFeeds.RssFeedsColumns.UPDATE_CYCLE);
        RSSFEED_PROJECTION_MAP.put(RssFeeds.RssFeedsColumns.LAST_UPDATE,RssFeeds.RssFeedsColumns.LAST_UPDATE);

        //RssFeedContentse[u̍ږƑ̃}bsO
        RSSCONTENT_PROJECTION_MAP=new HashMap<String,String>();
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns._ID,RssFeeds.RssFeedContentsColumns._ID);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns._COUNT,RssFeeds.RssFeedContentsColumns._COUNT);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns.CHANNEL_ID,RssFeeds.RssFeedContentsColumns.CHANNEL_ID);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns.ITEM_TITLE,RssFeeds.RssFeedContentsColumns.ITEM_TITLE);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns.ITEM_AUTHOR,RssFeeds.RssFeedContentsColumns.ITEM_AUTHOR);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns.ITEM_LINK,RssFeeds.RssFeedContentsColumns.ITEM_LINK);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns.ITEM_DESCRIPTION,RssFeeds.RssFeedContentsColumns.ITEM_DESCRIPTION);
        RSSCONTENT_PROJECTION_MAP.put(RssFeeds.RssFeedContentsColumns.PUB_DATE,RssFeeds.RssFeedContentsColumns.PUB_DATE);
    }
    /**
     * RecvoC_
     */
    private static ContentResolver mContentResolver;
    /**
     * DBփf[^}
     * @param uri
     * @param cv
     * @return
     */
    public static Uri insert(Uri uri, ContentValues cv){
        return mContentResolver.insert(uri,cv);
    }
    /**
     * Ώۂ̃f[^݂Ȃꍇ̓CT[gB݂ꍇ́A
     * Ώۂ̃f[^sԂ
     * @param uri
     * @param selection
     * @param selectionArgs
     * @param cs
     * @return
     */
    public static Uri insertIfNotExists(Uri uri,String selection,String[] selectionArgs,ContentValues cs){
        Uri u=null;

        String[] projection={BaseColumns._ID};
        Cursor c=mContentResolver.query(uri,projection,selection,selectionArgs,null);
        if (c.getCount()<=0){
            u=insert(uri,cs);
        }else{
            c.moveToFirst();
            String tid=c.getString(c.getColumnIndex(BaseColumns._ID));
            u = ContentUris.withAppendedId(uri,Long.parseLong(tid));
       }
       c.close();
       return u;
    }
    /**
     * DB̍폜
     * @param uri
     * @param selection
     * @param selectionArgs
     * @return
     */
    public static int delete(Uri uri,String selection,String[] selectionArgs){
        return mContentResolver.delete(uri,selection,selectionArgs);
    }
    /**
     * DB̍XV
     * @param uri
     * @param values
     * @param selection
     * @param selectionArgs
     * @return
     */
    public static int update(Uri uri,ContentValues values, String selection, String[] selectionArgs){
        return mContentResolver.update(uri,values,selection,selectionArgs);
    }
    /**
     * DB̃NGs
     * @param uri
     * @param values
     * @param selection
     * @param selectionArgs
     * @return
     */
    public static Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs, String sortOrder) {
        return mContentResolver.query(uri,projection,selection,selectionArgs,sortOrder);
    }
    /**
     * Rec]o[̎擾
     * @return
     */
    public static ContentResolver getContentResolver() {
        return mContentResolver;
    }
    /**
     * Rec]o[̃Zbg
     * @param contentResolver
     */
    public static void setContentResolver(ContentResolver contentResolver) {
        mContentResolver = contentResolver;
    }
}
