package com.example.widget;


import java.util.Date;

import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.ClipboardManager;
import android.util.Log;
import android.widget.RemoteViews;
import android.widget.Toast;

/** 
 * {^NbNEBWFbgTv 
 */
public class ClickSample extends AppWidgetProvider {
	
    private static final String TIME_ACTION = "TIME_ACTION";	//ݎ\ANV
    private static final String PAST_ACTION = "PAST_ACTION";	//y[XgANV
    private static final String TAG_ = "ClickSample";
    /**
     * XV
     * @param	context	ReLXg
     * @param	appWidgetManager	EBWFbg}l[W
     * @param	appWidgetIds	EBWFbgʂID
     * 
     */
	 @Override
     public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
        // WidgetXVĂ
        for(int i = 0; i < appWidgetIds.length; i++) {
            int appWidgetId = appWidgetIds[i];
            updateWidget(context, appWidgetManager, appWidgetId);
        }
     }
	 /**
	  * 폜
     * @param	context	ReLXg
     * @param	appWidgetIds	EBWFbgʂID
	  */
	 @Override
	 public void onDeleted(Context context, int appWidgetIds[]){
		 Log.d(TAG_,"onDeleted");
	 }
	 /**
	  * Enable
     * @param	context	ReLXg
	  */
	 @Override
	 public void onEnabled(Context context){
		 Log.d(TAG_,"onEnabled");
	 }
	 /**
	  * Disable
     * @param	context	ReLXg
	  */
	 @Override
	 public void onDisabled(Context context){
		 Log.d(TAG_,"onEnabled");
	 }
	 /**
	  * EBWFbgEventɌĂяoToast\
     * @param	context	ReLXg
     * @param	intent	Intent
	  */
     @Override
     public void onReceive(Context context, Intent intent) {
         final String action = intent.getAction();
         super.onReceive(context, intent);
         if(action.equals(AppWidgetManager.ACTION_APPWIDGET_DELETED)){
             //폜Deleteƃg[Xg\
             Toast.makeText(context, "Delete", Toast.LENGTH_LONG).show();
             
         }else if(action.equals(AppWidgetManager.ACTION_APPWIDGET_UPDATE)){
             //폜Deleteƃg[Xg\
             Toast.makeText(context, "udpate", Toast.LENGTH_LONG).show();
             
         }else if(action.equals(AppWidgetManager.ACTION_APPWIDGET_ENABLED)){
             //폜Deleteƃg[Xg\
             Toast.makeText(context, "Enable", Toast.LENGTH_LONG).show();
             
         }else if(action.equals(AppWidgetManager.ACTION_APPWIDGET_DISABLED)){
             //폜Deleteƃg[Xg\
             Toast.makeText(context, "disabled", Toast.LENGTH_LONG).show();
             
         }
     }
     //z[XN[EBWFbg̍XV
     public void updateWidget(Context context, AppWidgetManager manager,int id) {
    	 //[gr[̐
    	 RemoteViews remoteView = new RemoteViews(context.getPackageName(),R.layout.click_sample_layout);
    	 
         //{^ɌĂяoNX
    	 Intent intentTime = new Intent(context, ButtonReceiver.class);
         Intent intentPast = new Intent(context, ButtonReceiver.class);
         intentTime.setAction(TIME_ACTION);
         intentPast.setAction(PAST_ACTION);
    	 intentTime.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, id);
    	 intentPast.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, id);
         
         //{^ɎsPendingIntent擾
    	 //NGXgR[hɕKEBWFbgIDw肷邱
         PendingIntent pendingIntentTime = PendingIntent.getBroadcast(context, id,intentTime, 0);
         PendingIntent pendingIntentPast = PendingIntent.getBroadcast(context, id,intentPast, 0);
        
         //{^ButtonReceiverNXĂяoݒ
         remoteView.setOnClickPendingIntent(R.id.timeButton, pendingIntentTime);
         remoteView.setOnClickPendingIntent(R.id.pastButton, pendingIntentPast);
         //IDɎw肵EBWFbg`
         manager.updateAppWidget(id,remoteView);
     }
     /**
      * 
      * EBWFbg̃{^ɌĂяo郌V[o[
      *
      */
     public static class ButtonReceiver extends BroadcastReceiver {

		@Override
		public void onReceive(Context context, Intent intent) {
			RemoteViews remoteView = new RemoteViews(context.getPackageName(), R.layout.click_sample_layout);
			AppWidgetManager manager = AppWidgetManager.getInstance(context);
			ComponentName thisWidget = new ComponentName(context, ClickSample.class);
			
			//ANVɂ蕪
			//\{^
			if (TIME_ACTION.equals(intent.getAction())) {
				//ݎ\
          		remoteView.setTextViewText(R.id.dispText, new Date().toLocaleString());
          	//y[Xg{^
      		}else if (PAST_ACTION.equals(intent.getAction()) ) {
      			//Nbv{[h}l[W[擾
    			ClipboardManager cm = (ClipboardManager) context.getSystemService(Context.CLIPBOARD_SERVICE);
    			if(cm.getText().equals("")){
    				cm.setText("Nbv{[hɒlRs[Ă܂");
    			}
    			//Nbv{[h̒l\
          		remoteView.setTextViewText(R.id.dispText, cm.getText());
      		}
			//ݒ肵e𓯂EBWFbg̑SĂɕ`
			//manager.updateAppWidget(thisWidget, remoteView);
	         //IDɎw肵EBWFbg`
			Bundle extras = intent.getExtras();
			
			//IntentɎw肵l擾łȂꍇL̏s邱ƂŎ擾łꍇ
//			if(extras != null){
//				extras.getInt(
//			            AppWidgetManager.EXTRA_APPWIDGET_ID, 
//			            AppWidgetManager.INVALID_APPWIDGET_ID);
//			}
			int id = extras.getInt(AppWidgetManager.EXTRA_APPWIDGET_ID);
			manager.updateAppWidget(id,remoteView);
			
		}

     }
}